<?php
date_default_timezone_set('Europe/Paris');
require_once('lib/classes/class.lexan.php');
require_once('lib/classes/class.syntan.php');
require_once('lib/classes/class.keyword.php');
require_once('lib/classes/class.exceptions.php');

define("MAX_CODE_LENGTH", 24000);

$files = array(
	"kod1" => "./index.php",
	"kod2" => "./lib/classes/class.lexan.php",
	"kod3" => "./lib/classes/class.syntan.php",
	"kod4" => "./lib/classes/class.keyword.php",
	"kod5" => "./lib/classes/class.exceptions.php",
	"bad1" => "./bad1.txt",
	"bad2" => "./bad2.txt",
	"bad3" => "./bad3.txt"
);

$code = "";
$error = array ();
$flags = array ("syntax", "highlight", "lineNumbers");
if (isset($_POST["sended"])) {
	$flags = $_POST["flag"];
	if ($_POST["predefined"]) {
		$code = @file_get_contents($files[$_POST["predefined"]]);
	} else if ($_POST['code'] && strlen($_POST["code"]) <= MAX_CODE_LENGTH) {
		$code = $_POST['code'];
		if (get_magic_quotes_gpc()) {
			$code = stripslashes($code);
		}
	} else if (strlen($_POST["code"]) > MAX_CODE_LENGTH) {
		$error [] = "Kód je příliš dlouhý (" . strlen($_POST["code"]) . " > MAX_CODE_LENGTH)";
	} else {
		$error [] = "Nezadali jste žádný kód";
	}
	$_POST['code'] = "";
}
if (isset($_GET['c']) && $_GET['c']) {
	$code = file_get_contents($files[$_GET["c"]]);
	$flags = array("highlight", "lineNumbers");
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="cs" xml:lang="cs">
<head>
	<meta http-equiv="Content-Type" content="text/xhtml; charset=utf-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
</head>
<style type="text/css">

body {
	background-color: #F2F2F2;
	margin: 10px;
}

form input, form select{
	border: none;
	border-bottom: 3px double;
	background-color: #F2F2F2;
}

#code {
	width: 100%;
	height: 300px;
	border: 1px solid;
	background-image: url('textarea.bg.png');
	background-color: #fff;
	background-repeat: no-repeat;
	background-position: top right;
}

optgroup {
	font-style: normal;
	font-weight: normal;
	border-top: 3px double;
}

optgroup option {
	padding-left: 0.5em;
}

label {
	width: 100%;
	display: block;
	padding-right: 0.5em;
}

.code {
	border: 1px solid #D70; 
	overflow: auto;
	background-image: url('highlight.bg.png');
	background-color: #fff;
	background-repeat: no-repeat;
	background-position: top right;
}

#showCode {
	display: none;
}

#showCode textarea {
	width: 100%;
}

#states, .codePreview, #outputSymbols {
	border: 1px solid #07D; 
	overflow: auto;
	background-image: url('states.bg.png');
	background-color: #fff;
	background-repeat: no-repeat;
	background-position: top right;
	display: none;
}

#states {
	height: 400px;
}

.codePreview {
	background-image: none;
	display: block;
}

#outputSymbols {
	border: 1px solid #D07;
	background-image: url('out.bg.png');
	padding: 3px;
}

#outputSymbols h1 {
	margin: 1em 0px 3px 0px;
}

#outputSymbols h2 {
	padding-left: 3px;
	margin: 0.5em 0px 3px 0px;
}

#outputSymbols h3 {
	padding-left: 6px;
	margin: 0.3em 0px 3px 0px;
}

#outputSymbols h4 {
	padding-left: 9px;
	margin: 0.2em 0px 3px 0px;
}

#outputSymbols h5 {
	padding-left: 12px;
	margin: 0em 0px 3px 0px;
}

.OP {
	color: #900;
}

.KW {
	color: #009;
	font-weight: bold;
}

.STRING {
	color: #909;
}

.VAR {
	color: #090;
}

.INT, .FLOAT, .HEXA {
	color: #F00;
	font-weight: bold;
}
	
.IDENT {
	color: #55f
}

.WHITESPACE {
}

#selection {
	background-color: #fff;
	border-bottom: 3px inset;
	padding-bottom: 5px;
	margin-bottom: 10px;
	padding-top: 20px;
	padding-left: 2em;
	margin-left: -10px;
	margin-right: -10px;
	margin-top: -10px;
	z-index: 2;
}

#selection.form, #form_href {
	color: #333;
}

#form_href {
	z-index: 3;
}

#selection.showCode, #showCode_href {
	color: #F90;
}

#showCode_href {
	z-index: 2;
}

#selection.states, #states_href {
	color: #07D;
}

#states_href {
	z-index: 1;
}

#selection.outputSymbols, #outputSymbols_href {
	color: #D07;
}

#outputSymbols_href {
	z-index: 0;
}

#selection a {
	position: relative;
	border: 1px solid;
	border-bottom: none;
	padding: 5px;
	background-color: #ddd;
}

#selection a.active {
	border: 3px outset;
	border-bottom: none;
	padding-left: 3px;
	padding-right: 3px;
	padding-bottom: 8px;
	background-color: #f2f2f2;
	z-index: 3;
}

#selection a.active:hover {
	padding-bottom: 8px;
}

#selection a:hover {
	z-index: 4;
	border: 3px outset;
	border-bottom: none;
	padding-bottom: 5px;
	padding-left: 3px;
	padding-right: 3px;
	background-color: #fff;
}

.lineNumber {
	padding-left: 5px;
	background-color: #ddd;
	margin-right: 3px;
	border-right: 3px double #000;
	color: #000;
}

.bold {
	font-weight: bold;
	color: #900;
}

.HTML, .COMMENT {
	color: #AAA;
}

.error {
	color: #d33;
	display: block;
	line-height: 2em;
}

#outputSymbols table {
	margin-left: 2em;
	line-height: 1.4em;
	border: 1px solid #222;
}

#outputSymbols table tbody {
	background-color: #fff;
}

#outputSymbols table tbody.odd {
	background-color: #CCC;
}

#outputSymbols table th {
	background-color: #222;
	color: #ddd;
}

#outputSymbols table * {
	padding: 1px 1em;
}
</style>

<script type="text/javascript">
function show(id){
	ids = new Array ("form","showCode","states", "outputSymbols");
	document.getElementById("selection").className = id;
	for (var i = 0; i < ids.length; i++) {
		if (ids[i] == id) {
			try {
				document.getElementById(id).style.display = "block";
			} catch (e) {}
			try {
				document.getElementById(id + "_href").className = "active";
			} catch (e) {}
		} else {
			try {
				document.getElementById(ids[i]).style.display = "none";
			} catch (e) {}
			try {
				document.getElementById(ids[i] + "_href").className = "";
			} catch (e) {}
		}
	}
}

</script>
<body<?php echo isset($_GET['c']) ? " onload=\"show('showCode')\" " : ""; ?>>
	<div id="selection" class="form">
		<a id="form_href" class="active" href="javascript:show('form');">Formulář</a>
		<?php if (in_array("highlight", $flags)) { ?><a id="showCode_href" href="javascript:show('showCode');">Zvýraznění syntaxe</a><?php } ?>
		<?php if (in_array("states", $flags)) { ?><a id="states_href" href="javascript:show('states');">Seznam stavů</a><?php } ?>
		<?php if (in_array("outputSymbols", $flags)) { ?><a id="outputSymbols_href" href="javascript:show('outputSymbols');">Přehled funkcí a tříd</a><?php } ?>
	</div>
	<?php
	if (!empty($error)) {
		echo "<strong class=\"error\">" . implode("<br />", $error) . "</strong>";
	}
	?>
	<form action="?" method="post" id="form">
		<label for="code">Zdrojový kód (maximální délka <?php echo MAX_CODE_LENGTH; ?> znaků (cca <?php echo round(MAX_CODE_LENGTH/34, -2); ?> řádků kódu))  :</label>
		<textarea id="code" name="code"><?php echo htmlspecialchars($code); ?></textarea><br />
		<table>
		<tr>
		<td><label for="predefined">Můžete si také vybrat některý z předpřipravených souborů</label>
		</td><td>
			<select id="predefined" name="predefined">
					<option value="" selected="selected" >žádný</option>
				<optgroup label="Funkční kódy">
					<option value="kod1">Tento soubor (index.php)</option>
					<option value="kod2">Zdrojový kód lexikálního analyzátoru</option>
					<option value="kod3">Zdrojový kód syntaktického analyzátoru</option>
				</optgroup>
				<optgroup label="Kódy s chybami">
					<option value="bad1">Špatné násobení</option>
					<option value="bad2">Neukončený komentář</option>
					<option value="bad3">
						Více chyb v jednom souboru (zkuste debuggovat)
					</option>
				</optgroup>
			</select>
			</td>
		</tr>
		<tr><td>
		<label for="flag1">Kontrolovat syntaxi</label></td><td>
			<input type="checkbox" name="flag[]" id="flag1" value="syntax" onchange="if (this.checked == false) { document.getElementById('flag3').checked = false; document.getElementById('flag5').checked = false; }" <?php echo in_array("syntax", $flags) ? "checked" : ""; ?>/>
		</td>
		</tr>
		<tr><td>
		<label for="flag3" title="Pomalé a paměťově náročné, dlouhý výstup - nemusí se zobrazit celé">Zobrazit seznam stavů kterými program prošel</label></td><td>
			<input type="checkbox" name="flag[]" id="flag3" value="states" onchange="if (this.checked == true) document.getElementById('flag1').checked = true;" <?php echo in_array("states", $flags) ? "checked" : ""; ?> />
		</td>
		</tr>
		<tr><td>
		<label for="flag5" title="">Zobrazit seznam výstupních symbolů vyvolaných kódem</label></td><td>
			<input type="checkbox" name="flag[]" id="flag5" value="outputSymbols" onchange="if (this.checked == true) document.getElementById('flag1').checked = true;" <?php echo in_array("outputSymbols", $flags) ? "checked" : ""; ?> />
		</td>
		</tr>
		<tr><td>
		<label for="flag4">Zobrazit zvýrazněný kód</label></td><td>
			<input type="checkbox" name="flag[]" id="flag4" value="highlight" <?php echo in_array("highlight", $flags) ? "checked" : ""; ?>  onchange="if (this.checked == false) document.getElementById('flag2').checked = false;"/>
		</td>
		</tr>
		<tr><td>
		<label for="flag2">Zobrazovat čísla řádků</label></td><td>
			<input type="checkbox" name="flag[]" id="flag2" value="lineNumbers" <?php echo in_array("lineNumbers", $flags) ? "checked" : ""; ?>  onchange="if (this.checked == true) document.getElementById('flag4').checked = true;" />
		</td>
		</tr>
		<tr><td></td><td>
			<input type="submit" value="Odeslat" name="sended" />
		</td>
		</tr>
		</table>
		</tr>
	</form>
	<?php
	if ($code && empty($error)) {
	$kw = array("and" => "T_LOGICAL_AND", "or" => "T_LOGICAL_OR", "xor" => "T_LOGICAL_XOR",
		"array", "as", "break", "case",
		"class", "const", "continue", "declare", "default",
		"die", "do", "echo", "else", "elseif",
		"empty", "enddeclare", "endfor", "endforeach", "endif",
		"endswitch", "endwhile", "exit", "extends" => "EXTEND",
		"for", "foreach", "function", "global", "if",
		"include", "include_once", "list", "new",
		"print", "require", "require_once", "return", "static",
		"switch", "use", "var", "while", "final", 
		"interface", "implements" => "IMPLEMENT", "public", "private",
		"protected", "abstract", "clone", "try", "catch",
		"throw", "true", "false", "null", "instanceof"
		);

	$specials = array("'" => "APOS", "\"" => "QUOTE", "=" => "ASSIGN", "\\" => "BACKSLASH", "/" => "DIVIDE",
		"*" => "MULTIPLE", ">" => "MORE", "<" => "LESS", ">=" => "MORE_OR_EQUAL", "<=" => "LESS_OR_EQUAL",
		"==" => "EQUAL", "===" => "SAFE_EQUAL", "!=" => "NOT_EQUAL", "!==" => "SAFE_NOT_EQUAL" ,"=>" => "AS",
		"->" => "INSTANCE_PROPERTY", "-" => "SUBS", "+" => "ADD", "&&" => "AND", "<>" => "NOT_EQUAL",
		"&" => "AMP", "||" => "OR", "|" => "PIPE", "," => "COMMA", "(" => "OPEN_BRACKET", ")" => "CLOSE_BRACKET",
		"{" => "OPEN_BLOCK", "}" => "CLOSE_BLOCK", "[" => "OPEN_LIST", "]" => "CLOSE_LIST", "." => "DOT",
		";" => "SEMICOLON", "!" => "NON", ":" => "COLON","::" => "CLASS_PROPERTY", "?" => "QUOTATION",
		"<?" => "PHP_OPEN_TAG", "<?php" => "PHP_OPEN_TAG", "<%" => "PHP_OPEN_TAG",
		"<?=" => "PHP_OPEN_TAG", "<%=" => "PHP_OPEN_TAG", "?>" => "PHP_CLOSE_TAG", 
		"%>" => "PHP_CLOSE_TAG", "%" => "MODULO", "@" => "MUTE",
		"+=" => "ASSIGN_INCREMENT", "-=" => "ASSIGN_DECREMENT", "*=" => "ASSIGN_MULTIPLY",
		"/=" => "ASSIGN_DIVIDE", "|=" => "ASSIGN_BINARY_OR", "&=" => "ASSIGN_BINARY_AND", ".=" => "ASSIGN_DOT",
		"^" => "XOR", "^=" => "ASSIGN_BINARY_XOR", "(int)" => "TYPE", "(float)" => "TYPE", "(real)" => "TYPE",
		"(double)" => "TYPE", "(bool)" => "TYPE", "(boolean)" => "TYPE", "(string)" => "TYPE", "(array)" => "TYPE", "(object)" => "TYPE",
		"%=" => "ASSIGN_MODULO", "<<=" => "ASSIGN_BINARY_LEFT", ">>=" => "ASSIGN_BINARY_RIGHT",
		"++" => "INCREMENT", "--" => "DECREMENT", "~" => "COMPLEMENT", "<<" => "SHIFT_LEFT", ">>" => "SHIFT_RIGHT"
		);

	$startTime = microtime(true);
	$phpKw = new KeyWord($kw, $specials);
	$phpLexAn = new Lexan($code, $phpKw);
	//echo "<xmp>" . print_r($flags, true) . "</xmp>";
	try {
		$anFlag = (in_array("lineNumbers", $flags) ? Lexan::_ADD_LINE_NUMBERS : 0);
		$phpLexAn->analyze($anFlag);
		if (in_array("syntax", $flags)) {
			$phpSynAn = new Syntan();
			$phpSynAn->parse($phpLexAn->getTerms(), in_array("states", $flags), in_array("outputSymbols", $flags));
			echo "<small>Kontrola syntaxe proběhla v pořádku, soubor má " . strlen($code) . " znaků.</small><br />";
			if (in_array("states", $flags)) {
				echo "<pre id=\"states\">";
					$phpSynAn->printPassed();
				echo "</pre>";
			}
			if (in_array("outputSymbols", $flags)) {
				echo "<pre id=\"outputSymbols\">";
				$out = $phpSynAn->getOutput();
				$symbol = true; $context;
				function getNextSymbol(){
					global $symbol, $out, $context, $phpLexAn;
					if(!sizeof($out)) {
						$symbol = $context = false;
						return;
					}
					$symbol = array_shift($out);
					$context = $phpLexAn->getSymbol($symbol['id']);	
				}
				function printFunction($functionArray){
					echo "<table class=\"function\" cellspacing=\"0\">";
					echo "<tr><th>Řádek</th><th>Název</th><th>Vstupní parametry</th><th>Typ</th><th>Výchozí hodnota</th></tr>";
					$odd = true;
					foreach($functionArray as $method){
						$rowCount = max(sizeof($method['params']), 1);
						$odd = !$odd;
						echo "<tbody class=\"" . ($odd ? "odd" : "") . "\">";
						echo "<tr><td rowspan=\"" . $rowCount . "\">"
							 . printLine($method['from']) . "</td><td rowspan=\"" . $rowCount
							 . "\">" . $method['name'] . "</td>";
						$first = true;
						if (sizeof($method['params'])) {
							foreach($method['params'] as $param){
								if(!$first) {
									echo "<tr>";
								}
								echo "<td>" . $param["name"]. "</td>" .
									(isset($param["type"]) ? "<td>" . $param["type"] . "</td>" : "<td></td>").
									(isset($param["default"]) ? "<td>" . htmlspecialchars($param["default"]) . "</td>" : "<td></td>");
								echo "</tr>";
							}
							$first = false;
						} else {
							echo "<td colspan=\"3\">Bez parametrů</td></tr>";
						} 
						echo (!isset($method['define']) || $method['define'] 
							? ""
							: "<tr><td colspan=\"5\">pouze deklarace, bez definice</td></tr>"
						);
						echo "</tbody>";
					}
					echo "</table>";
				}
				function printVars($consts){
					echo "<table class=\"vars\" cellspacing=\"0\">";
					echo "<tr><th>Řádek</th><th>Název</th><th>Hodnota</th></tr>";
					$odd = true;
					foreach($consts as $var){
						$odd = !$odd;
						echo "<tbody class=\"" . ($odd ? "odd" : "") . "\">";
						echo "<tr><td>" . printLine($var['from']) . "</td><td>" . $var['name'] . "</td>";
						echo "<td>".(isset($var['predefined']) ? htmlspecialchars($var['predefined']) : "") . "</td></tr>";
						echo "</tbody>";
					}
					echo "</table>";
				}
				function printClassLike($classes){
					foreach($classes as $class){
						echo "<h2>" . $class['name'] . "</h2>";
						echo "<small>Definována na řádku " . printLine($class['from']) . 
							", obsahuje " . sizeof($class['methods']) . 
							" metod, " . sizeof($class['consts']) .
							" konstant a " . sizeof($class['variables']) . " proměnných</small>";
						if (isset($class['consts']) && sizeof($class['consts'])) {
							echo "<h3>Konstanty</h3>";
							printVars($class["consts"]);
						}
						if (isset($class['variables']) && sizeof($class['variables'])) {
							echo "<h3>Proměnné</h3>";
							printVars($class["variables"]);
						}
						if (isset($class['methods']) && sizeof($class['methods'])) {
							echo "<h3>Metody</h3>";
							printFunction($class['methods']);
						}
					}
				}
				function printLine($lineNumber){
					global $flags;
					if(in_array("lineNumbers", $flags)){
						return "<a href=\"#l".$lineNumber."\" onclick=\"show('showCode');\" class=\"lineHref\">".$lineNumber."</a>";
					} else {
						return $lineNumber;
					}
				}
				$symbols = array();
				$symbols ['staticVars'] = $symbols ['functions'] = $symbols ['classes'] = $symbols ['other'] = array();
				$symbols ['interfaces'] = array();
				getNextSymbol();
				while($symbol){
					$undefine = false;
					switch($symbol['name']){
						case "__STATIC_VAR_DECLARATION":
							$staticVars = &$symbols["staticVars"];
							$staticVarsIndex = sizeof($staticVars);
							$staticVars [$staticVarsIndex] ["name"] = $context[1];
							$staticVars [$staticVarsIndex] ["from"] = $context[2];
							$staticVars [$staticVarsIndex] ["to"] = $context[3];
							getNextSymbol();
							if($symbol['name'] == "__STATIC_VAR_VALUE"){
								$staticVars [$staticVarsIndex] ["default"] = $context[1];
								getNextSymbol();
							}
						break;
						case "__FUNCTION_DECLARE":
							$lastFunction = "function";
							$functions = &$symbols["functions"];
							$functionIndex = sizeof($functions);
							$functions [$functionIndex] ["name"] = $context[1];
							$functions [$functionIndex] ["from"] = $context[2];
							$functions [$functionIndex] ["to"] = $context[3];
							$functions [$functionIndex] ["params"] = array();
							getNextSymbol();
						break;
						case "__FUNCTION_PARAM_TYPE":
							if($lastFunction === "function") {
								$functions = &$symbols["functions"];
							} else if ($lastFunction === "method") {
								$functions = &$symbols['classes'];
								$functions = &$functions[sizeof($functions) - 1]["methods"];
							} else {
								$functions = &$symbols['interfaces'];
								$functions = &$functions[sizeof($functions) - 1]["methods"];
							}
							$functionIndex = sizeof($functions) - 1;
							$paramIndex = sizeof($functions [$functionIndex] ['params']);
							$functions [$functionIndex] ['params'] [$paramIndex] ['type'] = $context [1];
							getNextSymbol();
							break;
						case "__FUNCTION_PARAM":
							if($lastFunction === "function") {
								$functions = &$symbols["functions"];
							} else if ($lastFunction === "method") {
								$functions = &$symbols['classes'];
								$functions = &$functions[sizeof($functions) - 1]["methods"];
							} else {
								$functions = &$symbols['interfaces'];
								$functions = &$functions[sizeof($functions) - 1]["methods"];
							}
							$functionIndex = sizeof($functions) - 1;
							$paramIndex = sizeof($functions [$functionIndex] ['params']) - 1;
							if(isset($functions [$functionIndex] ['params'] [$paramIndex] ['name'])) {
								$paramIndex++;
							}
							$functions [$functionIndex] ['params'] [$paramIndex] ['name'] = $context [1];
							getNextSymbol();
							if($symbol['name'] == "__L_PARAM_DEFAULT_VALUE"){
								$functions [$functionIndex] ["params"] [$paramIndex] ['default'] = "";
								$id = $symbol['id']; 
								while($symbol['name'] != "__P_PARAM_DEFAULT_VALUE"){
									getNextSymbol();
								}
								for ($id; $id <= $symbol['id']; $id++){
									$cont = $phpLexAn->getSymbol($id);
									$functions [$functionIndex] ["params"] [$paramIndex] ['default'] .= $cont [1];
								}
								getNextSymbol();
							}
						break;
						case "__CLASS_DECLARE": 
							$classes = &$symbols['classes'];
							$classesIndex = sizeof($classes);
							$classes [$classesIndex] ["name"] = $context[1];
							$classes [$classesIndex] ["from"] = $context[2];
							$classes [$classesIndex] ["to"] = $context[3];
							$classes [$classesIndex] ["methods"] = array();
							$classes [$classesIndex] ["variables"] = array();
							$classes [$classesIndex] ["consts"] = array();
							getNextSymbol();
						break;
						case "__INTERFACE_DECLARATION":
							$classes = &$symbols['interfaces'];
							$classesIndex = sizeof($classes);
							$classes [$classesIndex] ["name"] = $context[1];
							$classes [$classesIndex] ["from"] = $context[2];
							$classes [$classesIndex] ["to"] = $context[3];
							$classes [$classesIndex] ["methods"] = array();
							$classes [$classesIndex] ["consts"] = array();
							getNextSymbol();
						break;
						case "__METHOD_DECLARE":
							$undefine = true;
						case "__METHOD_DEFINE":
							$lastFunction = "method";
							$methods = &$symbols['classes'];
							$methods = &$methods[sizeof($methods) - 1]['methods'];
							$index = sizeof($methods);
							$methods [$index] ["name"] = $context[1];
							$methods [$index] ["define"] = (!$undefine);
							$methods [$index] ["from"] = $context[2];
							$methods [$index] ["params"] = array();
							$undefine = false;
							getNextSymbol();
						break;
						case "__CLASS_PROPERTY_DECLARE":
							$vars = &$symbols['classes'];
							$vars = &$vars[sizeof($vars) - 1]['variables'];
							$index = sizeof($vars);
							$vars [$index] ["name"] = $context[1];
							$vars [$index] ["from"] = $context[2];
							getNextSymbol();
						break;
						case "__L_CLASS_VARIABLE_ASSIGN":
							$vars = &$symbols['classes'];
							$vars = &$vars[sizeof($vars) - 1]['variables'];
							$index = sizeof($vars) - 1;
							$vars [$index] ["predefined"] = "";
							$id = $symbol['id']; 
							while($symbol['name'] != "__P_CLASS_VARIABLE_ASSIGN"){
								getNextSymbol();
							}
							for ($id; $id <= $symbol['id']; $id++){
								$cont = $phpLexAn->getSymbol($id);
								$vars [$index] ["predefined"] .= $cont[1];
							}
							// while
							getNextSymbol();
						break;
						case "__CLASS_CONST_DECLARE": 
							$vars = &$symbols['classes'];
							$vars = &$vars[sizeof($vars) - 1]['consts'];
							$index = sizeof($vars);
							$vars [$index] ["name"] = $context[1];
							$vars [$index] ["from"] = $context[2];
							getNextSymbol();
							break;
						case "__L_CLASS_CONST_VALUE":
							$vars = &$symbols['classes'];
							$vars = &$vars[sizeof($vars) - 1]['consts'];
							$index = sizeof($vars) - 1;
							$vars [$index] ["predefined"] = "";
							$id = $symbol['id']; 
							while($symbol['name'] != "__P_CLASS_CONST_VALUE"){
								getNextSymbol();
							}
							for ($id; $id <= $symbol['id']; $id++){
								$cont = $phpLexAn->getSymbol($id);
								$vars [$index] ["predefined"] .= $cont[1];
							}
							// while
							getNextSymbol();
						break;
						case "__INTERFACE_METHOD_DECLARATION": 
							$lastFunction = "interface";
							$methods = &$symbols['interfaces'];
							$methods = &$methods[sizeof($methods) - 1]['methods'];
							$index = sizeof($methods);
							$methods [$index] ["name"] = $context[1];
							$methods [$index] ["define"] = false;
							$methods [$index] ["from"] = $context[2];
							$methods [$index] ["params"] = array();
							getNextSymbol();
						break;
						case "__INTERFACE_CONST_DECLARE": 
							$vars = &$symbols['interfaces'];
							$vars = &$vars[sizeof($vars) - 1]['consts'];
							$index = sizeof($vars);
							$vars [$index] ["name"] = $context[1];
							$vars [$index] ["from"] = $context[2];
							getNextSymbol();
							break;
						case "__L_INTERFACE_CONST_VALUE":
							$vars = &$symbols['interfaces'];
							$vars = &$vars[sizeof($vars) - 1]['consts'];
							$index = sizeof($vars) - 1;
							$vars [$index] ["predefined"] = "";
							$id = $symbol['id']; 
							while($symbol['name'] != "__P_INTERFACE_CONST_VALUE"){
								getNextSymbol();
							}
							for ($id; $id <= $symbol['id']; $id++){
								$cont = $phpLexAn->getSymbol($id);
								$vars [$index] ["predefined"] .= $cont[1];
							}
							// while
							getNextSymbol();
						break;
						default:
							getNextSymbol();
					} // switch
				}
				// výpis tříd
				ob_start();
				if (!empty($symbols['classes'])) {
					echo "<h1>Třídy</h1>";
					printClassLike($symbols['classes']);
				}
				if (!empty($symbols['interfaces'])) {
					echo "<h1>Interface</h1>";
					printClassLike($symbols['interfaces']);
				}
				if (sizeof($symbols['functions'])) {
					echo "<h3>Funkce</h3>";
					printFunction($symbols['functions']);
				}
				$functions = ob_get_flush();
				echo "<textarea>".htmlspecialchars($functions)."</textarea>";
				echo "</pre>";
			}
		}
		if (in_array("highlight", $flags)) {
			echo "<div id=\"showCode\">";
			echo "<pre class=\"code\">".$phpLexAn->getOut()."</pre>";
			echo "<textarea>".htmlspecialchars($phpLexAn->getOut())."</textarea>";
			echo "</div>";
		}
		$endTime = microtime(true);
		echo "<small>Vygenerováno za ".round($endTime-$startTime, 2)." vteřin.</small>";
	} catch (SynException $e) {
		echo "<div class=\"error\">";
		echo "<strong>".$e->getMessage()."</strong>, neočekávaný symbol <strong>".$e->getToken()."</strong>, očekáváno ";
		if (is_array($e->getExpected())) {
			$expected = array();
			foreach($e->getExpected() as $item => $next){
				if (strpos($item, "__") !== 0) {
					$expected [] = $item;
				}
			}
			echo "jedno z následujících: <br />".implode(", ", $expected);
		} else {
			echo ": ".$e->getExpected();
		}
		echo "<br />";
		list($symb, $value, $from, $to) = $phpLexAn->getSymbol($e->getTokenId());
		echo "Řádek <strong>" . $from . ($to > $from ? " - " . $to : "") . "</strong><br />";
		echo "Kód: <pre class=\"codePreview\">" . htmlspecialchars($value) . "</pre>";
		echo "</div>";
		echo "<style type=\"text/css\">.line_".$from."{background-color: #B00; color: #DDD;}</style>";
		if (in_array("highlight", $flags)) {
			echo "<pre id=\"showCode\">".$phpLexAn->getOut()."</pre>";
		}
	} catch (PJPException $e) {
		echo "<div class=\"error\">";
		echo "<strong>".$e->getMessage()."</strong> na řádku <strong>".$e->getCodeLine()."</strong>:";
		echo "<pre class=\"codePreview\">".htmlspecialchars($e->getCodePassage())."</pre>";
		echo "</div>";
	}
		?>
		<div id="codeBlock">
		<?php
		?>
		</div>
		<?php
	}
	$file1 = filemtime('index.php');
	$file2 = filemtime('lib/classes/class.lexan.php');
	$file3 = filemtime('lib/classes/class.syntan.php');
	$file4 = filemtime('lib/classes/class.keyword.php');
	$file5 = filemtime('lib/classes/class.exceptions.php');
	$file6 = filemtime('gramatika.txt');
	$file7 = filemtime('dokumentace.pdf');
	?>
	<small>&copy; <a href="http://yosarin.net">Yo'Sarin</a> (nebo <a href="http://blok.yosarin.net">blog</a>) &Xi; <a href="/dokumentace.pdf">Dokumentace</a> &Xi; <br />
	<strong>Poslední updaty</strong>:<br />
		<ul>
		<li>index.php - <?php echo date("d. n. Y, H:i:s", $file1); ?></li>
		<li>class.lexan.php - <?php echo date("d. n. Y, H:i:s", $file2); ?></li>
		<li>class.syntan.php -<?php echo date("d. n. Y, H:i:s", $file3); ?></li>
		<li>class.keyword.php - <?php echo date("d. n. Y, H:i:s", $file4); ?></li>
		<li>class.exceptions.php - <?php echo date("d. n. Y, H:i:s", $file5); ?></li>
		<li>gramatika.txt - <?php echo date("d. n. Y, H:i:s", $file6); ?></li>
		<li>dokumentace.pdf - <?php echo date("d. n. Y, H:i:s", $file7); ?></li>
		</ul> 
	</small>
</body>
