<?php

/**
 *
 *
 * @version $Id$
 * @copyright 2008
 */

class PJPException extends Exception{
	private $codePassage;
	private $codeLine;
	
	public function __construct($message, $codePassage = null, $codeLine = null){
		parent::__construct($message);
		$this->codePassage = $codePassage;
		$this->codeLine = $codeLine;
	}
	
	public function getCodePassage()
	{
		return $this->codePassage;
	}
	
	public function getCodeLine()
	{
		return $this->codeLine;
	}
}

/**
 *
 *
 */
class KwException extends PJPException{
	const WRONG_KW_NAME = "Bohužel jste zadali klíčové slovo ve špatném formátu";
	const DUPLICATE_KW_NAME = "Duplicitní klíčové slovo";
}

/** 
 * 
 *
 */
class LexException extends PJPException{
	const EXPECTED_ALPHA = "Byl očekáván znak A-Z nebo '_'";
	const UNTERMINATED_COMMENT = "Neukončený komentář";
	const TERMINATED_STRING = "Řetězec nebyl řádně ukončen";
	const UNKNOWN_SYMBOL = "Kód který jste zadali neodpovídá jazyku PHP";
	const EXPECTED_HEXA = "Byl očekáván znak 0-9 nebo A-F";
	const UNEXPECTED_DOT = "Neočekávaný znak '.'";
}

class SynException extends PJPException{
	private $expected;
	private $token;
	private $tokenId;
	
	public function __construct($message, $tokenId, $token = null, $expected = array()){
		parent::__construct($message);
		$this->expected = $expected;
		$this->token = $token;
		$this->tokenId = $tokenId;
	}
	
	public function getToken(){
		return $this->token;
	}
	
	public function getTokenId(){
		return $this->tokenId;
	}
	
	public function getExpected(){
		return $this->expected;
	}
	
	const BAD_SYNTAX = "Kód který jste zadali neodpovídá jazyku PHP";
	const BAD_SYMBOL = "Symbol není terminálním znakem jazyka";
	const WHAT_THE_HELL = "Prvek je neterminál, ale není v rozkladové tabulce!";
	const WHAT_THE_HELL_2 = "Prvek rozkladové tabulky není ani terminální ani neterminální symbol jazyka";
}
?>